#ifndef H_TOKENSTACK

#define H_TOKENSTACK

#include "token.h"
#define MIN_STACK_CAPACITY 64

typedef struct stack stack_t;

stack_t* stack_new();

token_t** stack_get_raw(const stack_t* stck);

unsigned long long stack_get_size(const stack_t* stck);

unsigned long long stack_get_capacity(const stack_t* stck);

void stack_set_min_capacity(stack_t* stck, const unsigned long long size);

void stack_push(stack_t* stck, token_t* tok);

token_t* stack_pop(stack_t* stck);

token_t* stack_access(stack_t* stck, const unsigned long long index);

token_t* stack_raccess(stack_t* stck, const unsigned long long index);

void stack_print(const stack_t* stck);

void stack_free(stack_t* stck);
#endif